#include "lcd.h"
#include "tools.c"

void lcd_init(void)                         // Initializing the Display
{
        outp(0xFF, DDRB);
        delay_ms(100);                     // Initializing...
        sbi(PORTB, 0x03);                        // Sending Signal three Times
        lcd_enable();
        delay_ms(30);
        sbi(PORTB, 0x03);
        lcd_enable();
        delay_ms(5);
        sbi(PORTB, 0x03);
        lcd_enable();

        delay_ms(5);                          // Function set
        outp(0x02, PORTB);
        lcd_enable();

        delay_ms(5);                          // Function set
        lcd_command(0x28);

        delay_ms(5);                   // Display on/off
        lcd_command(0x0F);

        delay_ms(5);                  // Entry mode set
        lcd_command(0x01);

        delay_ms(5);;                        // Display clear
        lcd_command(0x06);
        delay_ms(50);
};

void lcd_enable(void)                        // Enabling and Desenabling the Signal
{
        delay_ms(5);
        sbi(PORTB, 6);
        delay_ms(5);
        cbi(PORTB, 6);
};

void lcd_command(char data)                // Sending commands to the Display
{
          char temp;
          temp = data >> 4;
          outp(temp, PORTB);
          lcd_enable();
          temp = data & 0x0F;
          outp(temp, PORTB);
          lcd_enable();
};

void lcd_data(char data)                // Sending data to the Display
{
          char temp;
          temp = data >> 4;
          temp = temp | 0x10;
          outp(temp, PORTB);
          lcd_enable();
          temp = data & 0x0F;
          temp = temp | 0x10;
          outp(temp, PORTB);
          lcd_enable();
          delay_us(50);
};


void lcd_print(char *data)
{
    while(*data != 0)
    {
        lcd_data(*data++);
    };
};

void lcd_cls(void)
{
   lcd_command(0x01);
   lcd_enable;
   delay_us(20);
};

void lcd_home(void)
{
   lcd_command(0x02);
   lcd_enable;
};

/*void lcd_control(byte disonoff, byte curonoff, byte curblink)
{
   byte temp;
   outp(0x00,PORTA);
   toggle_E();
   temp=0x08;
   if (disonoff==1) temp|=0x04;
   if (curonoff==1) temp|=0x02;
   if (curblink==1) temp|=0x01;
   outp(temp,PORTA);
   toggle_E();
   lcd_delay(100);
};
*/
void lcd_position(char x, char y)
{
   lcd_command(screenpos[y-1][x-1]);
   lcd_enable;
};
